package com.ether;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.springframework.beans.factory.annotation.Required;
import org.springframework.transaction.annotation.Transactional;

import com.ether.dao.plot.PlotDAO;

public class ServiceToolsImpl implements ServiceTools {

	@Transactional(readOnly = true)
	public List<String> getListeDates() 
		throws ServiceException 
	{
		try {
			
			List<Date> dates = _plotDAO.getListeDistinctDates();
			final DateFormat shortFormat = new SimpleDateFormat("yyyy");
			Set<String> shortDates = new HashSet<String>();
		
			for (final Date aDate : dates) {
				shortDates.add(shortFormat.format(aDate));
			}
			return new ArrayList<String>(shortDates);

		} catch (PersistenceException e) {
			throw new ServiceException(
					ServiceException.ServiceCode.DATES_NOT_FOUND, e);
		}
	}

	@Required
	public void setPlotDAO(final PlotDAO plotDAO) {
		_plotDAO = plotDAO;
	}

	private PlotDAO _plotDAO;
}
