package com.ether;

import java.util.List;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import com.ether.instrument.Instrument;
import com.ether.instrument.InstrumentType;

/**
 * @author vmipsl
 * @date 24 jan 2011 
 */
public interface InstrumentService extends Service
{
    @NotNull
    Integer getNbInstruments() throws ServiceException;

    @Nullable
    List<Instrument> getAllInstruments() throws ServiceException;

    @Nullable
    Instrument getInstrumentById(@NotNull final Long instrumentId) throws ServiceException;
    
    @NotNull
    Long createInstrument(@NotNull final Instrument instrument) throws ServiceException;

    void removeInstrument(@NotNull final Long instrumentId) throws ServiceException;
    
    @Nullable 
    List<Instrument> getInstrumentsByStationId(@NotNull final Long stationId) throws ServiceException;
    
    @Nullable
    List<Instrument> getInstrumentsByType(@NotNull final InstrumentType type) throws ServiceException;
}
