package com.ether;

/**
 * @author vmipsl
 * @date 28 jan 2011 
 */
@SuppressWarnings("serial")
public class ServiceException 
	extends FormattedException
{
    public ServiceException(final Enum<? extends Code> code, final Throwable cause, final Object... parameters) {
	this(code, cause.getMessage(), cause, parameters);
    }

    protected ServiceException(final Enum<? extends Code> code, final String message, final Throwable cause, final Object... parameters) {
	super(prefix(code, message), cause, parameters);
    }

    public static enum ServiceCode implements Code 
    {
	UNKNOWN, 
	PERSISTENCE, 
	SERVICE_PROBLEM, 
	STATION_NOT_FOUND, 
	STATION_ALREADY_EXISTS,
	STATION_BY_ALTITUDE_NOT_FOUND,
	INSTRUMENT_NOT_FOUND,
	INSTRUMENT_BY_STATION_NOT_FOUND,	
	DATES_NOT_FOUND,
	DATES_PARSE_ERROR,
	INSTRUMENT_ERROR
    }
}
