package com.ether;

import java.util.List;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import com.ether.station.Station;

/**
 * @author vmipsl
 * @date 24 jan 2011
 */

public interface StationService extends Service
{
    @NotNull
    Integer getNbStations() throws ServiceException;

    @Nullable
    List<Station> getAllStations() throws ServiceException;

    @Nullable
    Station getStationById(@NotNull final Long stationId) throws ServiceException;
    
    //@Nullable
    Station getStationByName(@NotNull final String stationName) throws ServiceException;
    
    @NotNull
    Long createStation(@NotNull final Station station) throws ServiceException;

    void removeStation(@NotNull final Long stationId) throws ServiceException;
    
    @Nullable 
    List<Station> getStationsByAltitude(@NotNull final String  altitude) throws ServiceException;
}